/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 570:  /* ldstub */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 569:  /* swapsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 568:  /* *atomic_compare_and_swapdi_v8plus */
    case 567:  /* atomic_compare_and_swap_leon3_1 */
    case 566:  /* *atomic_compare_and_swapsi_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 561:  /* *membar_storeload */
    case 560:  /* *membar_storeload_leon3 */
    case 559:  /* *membar_storestore */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 563:  /* *membar */
    case 562:  /* *membar_v8 */
    case 558:  /* *membar_empty */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 551:  /* fpcmpugt8sishl */
    case 550:  /* fpcmpule8sishl */
    case 549:  /* fpcmpugt16sishl */
    case 548:  /* fpcmpule16sishl */
    case 547:  /* fpcmpugt32sishl */
    case 546:  /* fpcmpule32sishl */
    case 545:  /* fpcmpne8sishl */
    case 544:  /* fpcmpeq8sishl */
    case 543:  /* fpcmpgt8sishl */
    case 542:  /* fpcmple8sishl */
    case 541:  /* fpcmpne16sishl */
    case 540:  /* fpcmpeq16sishl */
    case 539:  /* fpcmpgt16sishl */
    case 538:  /* fpcmple16sishl */
    case 537:  /* fpcmpne32sishl */
    case 536:  /* fpcmpeq32sishl */
    case 535:  /* fpcmpgt32sishl */
    case 534:  /* fpcmple32sishl */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 524:  /* *nmuldf3_extend */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 477:  /* fmean16_vis */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 1), 0));
      break;

    case 466:  /* cmask32si_vis */
    case 465:  /* cmask16si_vis */
    case 464:  /* cmask8si_vis */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 519:  /* fpcmpueq32si_vis */
    case 518:  /* fpcmpugt32si_vis */
    case 517:  /* fpcmpune32si_vis */
    case 516:  /* fpcmpule32si_vis */
    case 515:  /* fpcmpueq16si_vis */
    case 514:  /* fpcmpugt16si_vis */
    case 513:  /* fpcmpune16si_vis */
    case 512:  /* fpcmpule16si_vis */
    case 511:  /* fucmpeq8si_vis */
    case 510:  /* fucmpgt8si_vis */
    case 509:  /* fucmpne8si_vis */
    case 508:  /* fucmple8si_vis */
    case 449:  /* fpcmpeq8si_vis */
    case 448:  /* fpcmpgt8si_vis */
    case 447:  /* fpcmpne8si_vis */
    case 446:  /* fpcmple8si_vis */
    case 445:  /* fcmpeq32si_vis */
    case 444:  /* fcmpgt32si_vis */
    case 443:  /* fcmpne32si_vis */
    case 442:  /* fcmple32si_vis */
    case 441:  /* fcmpeq16si_vis */
    case 440:  /* fcmpgt16si_vis */
    case 439:  /* fcmpne16si_vis */
    case 438:  /* fcmple16si_vis */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      break;

    case 437:  /* edge32lsi_vis */
    case 436:  /* edge32si_vis */
    case 435:  /* edge16lsi_vis */
    case 434:  /* edge16si_vis */
    case 433:  /* edge8lsi_vis */
    case 432:  /* edge8si_vis */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 429:  /* alignaddrlsi_vis */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 428:  /* alignaddrdi_vis */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 453:  /* bmasksi_vis */
    case 430:  /* alignaddrldi_vis */
    case 427:  /* alignaddrsi_vis */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 422:  /* rdgsr_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 421:  /* wrgsr_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 309:  /* stack_protect_testsi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 308:  /* stack_protect_setsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 307:  /* *tldo_stwsi */
    case 306:  /* *tldo_sthsi */
    case 305:  /* *tldo_stbsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 0), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 0), 0), 0), 0, 1));
      break;

    case 303:  /* *tldo_ldsh1si */
    case 302:  /* *tldo_lduh1si */
    case 300:  /* *tldo_ldsb2si */
    case 299:  /* *tldo_ldsb1si */
    case 298:  /* *tldo_ldub2si */
    case 297:  /* *tldo_ldub1si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0, 1));
      break;

    case 304:  /* *tldo_lduwsi */
    case 301:  /* *tldo_lduhsi */
    case 296:  /* *tldo_ldubsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 1));
      break;

    case 287:  /* tldm_callsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 283:  /* tgd_callsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 276:  /* prefetch_32 */
    case 275:  /* prefetch_64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 2));
      break;

    case 273:  /* clzdi_v8plus */
    case 271:  /* popcountdi_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 284:  /* tldm_hi22si */
    case 270:  /* stfsr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 266:  /* *branchsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 264:  /* update_return */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 533:  /* dictunpack8 */
    case 532:  /* dictunpack16 */
    case 531:  /* dictunpack32 */
    case 528:  /* fhsubdf_vis */
    case 527:  /* fhsubsf_vis */
    case 526:  /* fhadddf_vis */
    case 525:  /* fhaddsf_vis */
    case 476:  /* pdistnsi_vis */
    case 467:  /* fchksm16_vis */
    case 463:  /* edge32lnsi_vis */
    case 462:  /* edge32nsi_vis */
    case 461:  /* edge16lnsi_vis */
    case 460:  /* edge16nsi_vis */
    case 459:  /* edge8lnsi_vis */
    case 458:  /* edge8nsi_vis */
    case 457:  /* bshufflev8qi_vis */
    case 456:  /* bshufflev4hi_vis */
    case 455:  /* bshufflev2si_vis */
    case 454:  /* bshufflev1di_vis */
    case 452:  /* array32si_vis */
    case 451:  /* array16si_vis */
    case 450:  /* array8si_vis */
    case 426:  /* faligndatav8qi_vis */
    case 425:  /* faligndatav4hi_vis */
    case 424:  /* faligndatav2si_vis */
    case 423:  /* faligndatav1di_vis */
    case 420:  /* fmuld8ulx16_vis */
    case 419:  /* fmuld8sux16_vis */
    case 418:  /* fmul8ulx16_vis */
    case 417:  /* fmul8sux16_vis */
    case 416:  /* fmul8x16al_vis */
    case 415:  /* fmul8x16au_vis */
    case 414:  /* fmul8x16_vis */
    case 411:  /* fpack32_vis */
    case 263:  /* probe_stack_rangesi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 277:  /* trap */
    case 267:  /* flush_register_windows */
    case 265:  /* nop */
    case 262:  /* speculation_barrier */
    case 260:  /* blockage */
    case 259:  /* *return_internal */
    case 258:  /* eh_return_internal */
      break;

    case 269:  /* ldfsr */
    case 268:  /* flushsi */
    case 257:  /* window_save */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 252:  /* *call_symbolic_untyped_struct_value_sp32 */
    case 251:  /* *call_address_untyped_struct_value_sp32 */
    case 250:  /* *call_symbolic_struct_value_sp32 */
    case 249:  /* *call_address_struct_value_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (pat, 0, 1));
      break;

    case 255:  /* *sibcall_symbolicsi */
    case 248:  /* *call_symbolicsi */
    case 247:  /* *call_addresssi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 246:  /* *tablejumpsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 215:  /* *nfmssf4 */
    case 211:  /* *nfmsdf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 214:  /* *nfmasf4 */
    case 210:  /* *nfmadf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 213:  /* fmssf4 */
    case 209:  /* fmsdf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 212:  /* fmasf4 */
    case 208:  /* fmadf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 198:  /* *cmp_cc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 194:  /* *cmp_ccv_neg_sltu_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 192:  /* *cmp_ccv_neg */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 191:  /* *cmp_ccc_neg_sltu_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 193:  /* *cmp_ccv_neg_set */
    case 186:  /* negvdi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 183:  /* *cmp_cc_arith_op_not_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 182:  /* *cmp_cc_arith_op_not */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 181:  /* *cmp_cc_xor_not_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 180:  /* *cmp_cc_xor_not */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 179:  /* *cmp_cc_arith_op_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 178:  /* *cmp_cc_arith_op */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 521:  /* *nadddf3 */
    case 520:  /* *naddsf3 */
    case 413:  /* fpmerge_vis */
    case 366:  /* *not_xorv8qi3 */
    case 365:  /* *not_andv8qi3 */
    case 364:  /* *not_iorv8qi3 */
    case 363:  /* *not_xorv4hi3 */
    case 362:  /* *not_andv4hi3 */
    case 361:  /* *not_iorv4hi3 */
    case 360:  /* *not_xorv2si3 */
    case 359:  /* *not_andv2si3 */
    case 358:  /* *not_iorv2si3 */
    case 357:  /* *not_xorv1di3 */
    case 356:  /* *not_andv1di3 */
    case 355:  /* *not_iorv1di3 */
    case 354:  /* *not_xorv4qi3 */
    case 353:  /* *not_andv4qi3 */
    case 352:  /* *not_iorv4qi3 */
    case 351:  /* *not_xorv2hi3 */
    case 350:  /* *not_andv2hi3 */
    case 349:  /* *not_iorv2hi3 */
    case 348:  /* *not_xorv1si3 */
    case 347:  /* *not_andv1si3 */
    case 346:  /* *not_iorv1si3 */
    case 177:  /* *xor_not_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 171:  /* *umacdi */
    case 170:  /* *smacdi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 169:  /* *smacsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 166:  /* *cmp_sdiv_cc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 243:  /* lshrdi3_v8plus */
    case 241:  /* ashrdi3_v8plus */
    case 237:  /* ashldi3_v8plus */
    case 165:  /* divsi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 164:  /* xmulxhi_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 163:  /* xmulx_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 162:  /* umulxhi_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 161:  /* const_umulsi3_highpart */
    case 153:  /* const_smulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 160:  /* *umulsi3_highpart_sp32 */
    case 152:  /* *smulsi3_highpart_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 159:  /* const_umulsi3_highpart_v8plus */
    case 151:  /* const_smulsi3_highpart_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 158:  /* umulsi3_highpart_v8plus */
    case 150:  /* *sparc.md:4765 */
    case 149:  /* smulsi3_highpart_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 523:  /* *nmuldf3 */
    case 522:  /* *nmulsf3 */
    case 387:  /* *and_not1v8qi_vis */
    case 386:  /* *ior_not1v8qi_vis */
    case 385:  /* *and_not1v4hi_vis */
    case 384:  /* *ior_not1v4hi_vis */
    case 383:  /* *and_not1v2si_vis */
    case 382:  /* *ior_not1v2si_vis */
    case 381:  /* *and_not1v1di_vis */
    case 380:  /* *ior_not1v1di_vis */
    case 379:  /* *and_not1v4qi_vis */
    case 378:  /* *ior_not1v4qi_vis */
    case 377:  /* *and_not1v2hi_vis */
    case 376:  /* *ior_not1v2hi_vis */
    case 375:  /* *and_not1v1si_vis */
    case 374:  /* *ior_not1v1si_vis */
    case 175:  /* *or_not_si */
    case 173:  /* *and_not_si */
    case 156:  /* const_umulsidi3_sp32 */
    case 148:  /* const_mulsidi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 373:  /* *nandv8qi_vis */
    case 372:  /* *nandv4hi_vis */
    case 371:  /* *nandv2si_vis */
    case 370:  /* *nandv1di_vis */
    case 369:  /* *nandv4qi_vis */
    case 368:  /* *nandv2hi_vis */
    case 367:  /* *nandv1si_vis */
    case 217:  /* *multf3_extend */
    case 216:  /* *muldf3_extend */
    case 155:  /* *umulsidi3_sp32 */
    case 147:  /* *mulsidi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 157:  /* const_umulsidi3_v8plus */
    case 146:  /* const_mulsidi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 154:  /* umulsidi3_v8plus */
    case 145:  /* mulsidi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 143:  /* muldi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 138:  /* *cmp_ccc_minus_sltu_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1), 0);
      recog_data.dup_num[3] = 2;
      break;

    case 133:  /* *subdi3_extend_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 137:  /* *cmpsi_set */
    case 130:  /* usubvdi4_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 141:  /* *cmp_ccv_minus_sltu_set */
    case 128:  /* *cmp_ccv_plus_sltu_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0), 1);
      recog_data.dup_num[3] = 2;
      break;

    case 139:  /* *cmp_ccv_minus */
    case 126:  /* *cmp_ccv_plus */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0);
      recog_data.dup_num[1] = 0;
      break;

    case 125:  /* *cmp_ccc_plus_sltu_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 1), 0);
      recog_data.dup_num[3] = 2;
      break;

    case 123:  /* *cmp_ccc_plus */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 168:  /* *cmp_udiv_cc_set */
    case 144:  /* *cmp_mul_set */
    case 136:  /* *cmp_ccnz_minus_set */
    case 122:  /* *cmp_ccnz_plus_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 135:  /* *cmp_ccnz_minus */
    case 121:  /* *cmp_ccnz_plus */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 132:  /* *subx_extend_sp32 */
    case 118:  /* *addx_extend_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 140:  /* *cmp_ccv_minus_set */
    case 131:  /* subvdi4_sp32 */
    case 127:  /* *cmp_ccv_plus_set */
    case 117:  /* addvdi4_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 1);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0);
      recog_data.dup_num[3] = 1;
      break;

    case 124:  /* *cmp_ccc_plus_set */
    case 116:  /* uaddvdi4_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
      recog_data.dup_num[2] = 1;
      break;

    case 129:  /* subdi3_sp32 */
    case 115:  /* adddi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 96:  /* *cmp_zero_extract */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 90:  /* *cmp_zero_extendqisi2_andcc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 239:  /* *cmp_ccnz_set_ashift_1 */
    case 197:  /* *cmp_cc_set_not */
    case 190:  /* *cmp_ccc_neg_set */
    case 189:  /* *cmp_ccnz_neg_set */
    case 185:  /* unegvdi3_sp32 */
    case 92:  /* *cmp_siqi_trunc_set */
    case 89:  /* *cmp_zero_extendqisi2_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 245:  /* *jump_cbcond */
    case 244:  /* *jump_ubranch */
    case 88:  /* *cmp_zero_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 82:  /* *movtf_cc_v9 */
    case 81:  /* *movtf_cc_hq_v9 */
    case 80:  /* movdf_cc_v9 */
    case 79:  /* *movsf_cc_v9 */
    case 78:  /* *movsi_cc_v9 */
    case 77:  /* *movhi_cc_v9 */
    case 76:  /* *movqi_cc_v9 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 565:  /* atomic_storedi_1 */
    case 564:  /* atomic_loaddi_1 */
    case 412:  /* fexpand_vis */
    case 410:  /* fpackfix_vis */
    case 409:  /* fpack16_vis */
    case 261:  /* *frame_blockagesi */
    case 66:  /* embmedany_brsum */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 290:  /* tldo_addsi */
    case 282:  /* tgd_addsi */
    case 52:  /* *movsi_lo_sum_pic_label_ref */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      break;

    case 530:  /* fnhadddf_vis */
    case 529:  /* fnhaddsf_vis */
    case 51:  /* *movsi_high_pic_label_ref */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1));
      break;

    case 557:  /* fpcmpur8sishl */
    case 556:  /* fpcmpur16sishl */
    case 555:  /* fpcmpur32sishl */
    case 554:  /* fpcmpde8sishl */
    case 553:  /* fpcmpde16sishl */
    case 552:  /* fpcmpde32sishl */
    case 431:  /* pdist_vis */
    case 293:  /* tie_ld32 */
    case 50:  /* movsi_pic_gotdata_op */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 294:  /* tle_hix22si */
    case 291:  /* tie_hi22si */
    case 288:  /* tldo_hix22si */
    case 280:  /* tgd_hi22si */
    case 68:  /* embmedany_texthi */
    case 67:  /* embmedany_textuhi */
    case 64:  /* embmedany_sethi */
    case 61:  /* setlm */
    case 60:  /* sethh */
    case 57:  /* seth44 */
    case 49:  /* movsi_high_pic */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      break;

    case 295:  /* tle_lox10si */
    case 292:  /* tie_lo10si */
    case 289:  /* tldo_lox10si */
    case 286:  /* tldm_addsi */
    case 281:  /* tgd_lo10si */
    case 69:  /* embmedany_textulo */
    case 62:  /* sethm */
    case 58:  /* setm44 */
    case 48:  /* movsi_lo_sum_pic */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 316:  /* *movv8qi_insn_sp32 */
    case 315:  /* *movv4hi_insn_sp32 */
    case 314:  /* *movv2si_insn_sp32 */
    case 313:  /* *movv1di_insn_sp32 */
    case 312:  /* *movv4qi_insn */
    case 311:  /* *movv2hi_insn */
    case 310:  /* *movv1si_insn */
    case 279:  /* *trapdi_insn */
    case 278:  /* *trapsi_insn */
    case 75:  /* *movtf_insn_sp32 */
    case 74:  /* *movdf_insn_sp32 */
    case 71:  /* *movsf_insn */
    case 53:  /* *movdi_insn_sp32 */
    case 45:  /* *movsi_insn */
    case 43:  /* *movhi_insn */
    case 42:  /* *movqi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 41:  /* load_pcrel_symdi */
    case 40:  /* load_pcrel_symsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      break;

    case 39:  /* *cbcond_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 38:  /* *inverted_fpe_branch */
    case 36:  /* *inverted_fp_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 37:  /* *normal_fpe_branch */
    case 35:  /* *normal_fp_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 34:  /* *inverted_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 33:  /* *normal_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 29:  /* *minus_minus_sltusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      break;

    case 27:  /* *neg_plus_sltusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 26:  /* *minus_neg_sltusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 32:  /* *subxsi */
    case 24:  /* *addxsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 401:  /* *and_not2v8qi_vis */
    case 400:  /* *ior_not2v8qi_vis */
    case 399:  /* *and_not2v4hi_vis */
    case 398:  /* *ior_not2v4hi_vis */
    case 397:  /* *and_not2v2si_vis */
    case 396:  /* *ior_not2v2si_vis */
    case 395:  /* *and_not2v1di_vis */
    case 394:  /* *ior_not2v1di_vis */
    case 393:  /* *and_not2v4qi_vis */
    case 392:  /* *ior_not2v4qi_vis */
    case 391:  /* *and_not2v2hi_vis */
    case 390:  /* *ior_not2v2hi_vis */
    case 389:  /* *and_not2v1si_vis */
    case 388:  /* *ior_not2v1si_vis */
    case 28:  /* *minus_sltusi */
    case 23:  /* *minus_sgeusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 113:  /* fix_truncdfdi2 */
    case 112:  /* fix_truncsfdi2 */
    case 110:  /* fix_truncdfsi2 */
    case 109:  /* fix_truncsfsi2 */
    case 25:  /* *neg_sltusi */
    case 22:  /* *neg_sgeusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 21:  /* *plus_plus_sltusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 31:  /* *plus_sgeusi */
    case 20:  /* *plus_sltusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 408:  /* one_cmplv8qi2 */
    case 407:  /* one_cmplv4hi2 */
    case 406:  /* one_cmplv2si2 */
    case 405:  /* one_cmplv1di2 */
    case 404:  /* one_cmplv4qi2 */
    case 403:  /* one_cmplv2hi2 */
    case 402:  /* one_cmplv1si2 */
    case 285:  /* tldm_lo10si */
    case 274:  /* clzsi_v8plus */
    case 272:  /* popcountsi_v8plus */
    case 235:  /* sqrtsf2 */
    case 234:  /* *sqrtdf2_fix */
    case 233:  /* *sqrtdf2_nofix */
    case 232:  /* *sqrttf2_hq */
    case 231:  /* abssf2 */
    case 230:  /* *absdf2_v9 */
    case 229:  /* *absdf2_notv9 */
    case 228:  /* *abstf2 */
    case 227:  /* *abstf2_hq */
    case 226:  /* negsf2 */
    case 225:  /* *negdf2_v9 */
    case 224:  /* *negdf2_notv9 */
    case 223:  /* *negtf2 */
    case 222:  /* *negtf2_hq */
    case 195:  /* one_cmplsi2 */
    case 187:  /* negsi2 */
    case 114:  /* *fix_trunctfdi2_hq */
    case 111:  /* *fix_trunctfsi2_hq */
    case 108:  /* *floatditf2_hq */
    case 107:  /* floatdidf2 */
    case 106:  /* floatdisf2 */
    case 105:  /* *floatsitf2_hq */
    case 104:  /* floatsidf2 */
    case 103:  /* floatsisf2 */
    case 102:  /* *trunctfdf2_hq */
    case 101:  /* *trunctfsf2_hq */
    case 100:  /* truncdfsf2 */
    case 99:  /* *extenddftf2_hq */
    case 98:  /* *extendsftf2_hq */
    case 97:  /* extendsfdf2 */
    case 95:  /* *sign_extendqisi2_insn */
    case 94:  /* *sign_extendqihi2_insn */
    case 93:  /* *sign_extendhisi2_insn */
    case 86:  /* *zero_extendsidi2_insn_sp32 */
    case 85:  /* *zero_extendqisi2_insn */
    case 84:  /* *zero_extendqihi2_insn */
    case 83:  /* *zero_extendhisi2_insn */
    case 73:  /* *movsf_high */
    case 55:  /* *sethi_di_medlow */
    case 54:  /* *sethi_di_medlow_embmedany_pic */
    case 47:  /* *movsi_high */
    case 30:  /* *sgeusi_insn */
    case 19:  /* *sltusi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 16:  /* *minus_minus_snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 18:  /* *minus_seqsisi_zero */
    case 15:  /* *minus_snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 14:  /* *plus_plus_snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 256:  /* *sibcall_value_symbolicsi */
    case 254:  /* *call_value_symbolicsi */
    case 253:  /* *call_value_addresssi */
    case 119:  /* *adddi3_extend_sp32 */
    case 17:  /* *plus_seqsisi_zero */
    case 13:  /* *plus_snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 12:  /* *neg_seqsisi_zero */
    case 10:  /* *neg_snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      break;

    case 184:  /* negdi2_sp32 */
    case 11:  /* *seqsisi_zero */
    case 9:  /* *snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 507:  /* ussubv8qi3 */
    case 506:  /* usaddv8qi3 */
    case 505:  /* ussubv4hi3 */
    case 504:  /* usaddv4hi3 */
    case 503:  /* sssubv8qi3 */
    case 502:  /* ssaddv8qi3 */
    case 501:  /* maxuv2si3 */
    case 500:  /* minuv2si3 */
    case 499:  /* maxuv4hi3 */
    case 498:  /* minuv4hi3 */
    case 497:  /* maxuv8qi3 */
    case 496:  /* minuv8qi3 */
    case 495:  /* maxv2si3 */
    case 494:  /* minv2si3 */
    case 493:  /* maxv4hi3 */
    case 492:  /* minv4hi3 */
    case 491:  /* maxv8qi3 */
    case 490:  /* minv8qi3 */
    case 489:  /* sssubv1si3 */
    case 488:  /* ssaddv1si3 */
    case 487:  /* sssubv2hi3 */
    case 486:  /* ssaddv2hi3 */
    case 485:  /* sssubv2si3 */
    case 484:  /* ssaddv2si3 */
    case 483:  /* sssubv4hi3 */
    case 482:  /* ssaddv4hi3 */
    case 481:  /* subv8qi3 */
    case 480:  /* addv8qi3 */
    case 479:  /* fpsub64_vis */
    case 478:  /* fpadd64_vis */
    case 475:  /* vashrv2si3 */
    case 474:  /* vlshrv2si3 */
    case 473:  /* vssashlv2si3 */
    case 472:  /* vashlv2si3 */
    case 471:  /* vashrv4hi3 */
    case 470:  /* vlshrv4hi3 */
    case 469:  /* vssashlv4hi3 */
    case 468:  /* vashlv4hi3 */
    case 345:  /* xorv8qi3 */
    case 344:  /* andv8qi3 */
    case 343:  /* iorv8qi3 */
    case 342:  /* xorv4hi3 */
    case 341:  /* andv4hi3 */
    case 340:  /* iorv4hi3 */
    case 339:  /* xorv2si3 */
    case 338:  /* andv2si3 */
    case 337:  /* iorv2si3 */
    case 336:  /* xorv1di3 */
    case 335:  /* andv1di3 */
    case 334:  /* iorv1di3 */
    case 333:  /* xorv4qi3 */
    case 332:  /* andv4qi3 */
    case 331:  /* iorv4qi3 */
    case 330:  /* xorv2hi3 */
    case 329:  /* andv2hi3 */
    case 328:  /* iorv2hi3 */
    case 327:  /* xorv1si3 */
    case 326:  /* andv1si3 */
    case 325:  /* iorv1si3 */
    case 324:  /* subv4hi3 */
    case 323:  /* addv4hi3 */
    case 322:  /* subv2hi3 */
    case 321:  /* addv2hi3 */
    case 320:  /* subv2si3 */
    case 319:  /* addv2si3 */
    case 318:  /* subv1si3 */
    case 317:  /* addv1si3 */
    case 242:  /* lshrsi3 */
    case 240:  /* ashrsi3 */
    case 236:  /* ashlsi3 */
    case 221:  /* divsf3 */
    case 220:  /* *divdf3_fix */
    case 219:  /* *divdf3_nofix */
    case 218:  /* *divtf3_hq */
    case 207:  /* mulsf3 */
    case 206:  /* muldf3 */
    case 205:  /* *multf3_hq */
    case 204:  /* subsf3 */
    case 203:  /* subdf3 */
    case 202:  /* *subtf3_hq */
    case 201:  /* addsf3 */
    case 200:  /* adddf3 */
    case 199:  /* *addtf3_hq */
    case 176:  /* xorsi3 */
    case 174:  /* iorsi3 */
    case 172:  /* andsi3 */
    case 167:  /* udivsi3_sp32 */
    case 142:  /* *mulsi3_sp32 */
    case 134:  /* subsi3 */
    case 120:  /* addsi3 */
    case 72:  /* *movsf_lo_sum */
    case 70:  /* embmedany_textlo */
    case 65:  /* embmedany_losum */
    case 63:  /* setlo */
    case 59:  /* setl44 */
    case 56:  /* *losum_di_medlow */
    case 46:  /* *movsi_lo_sum */
    case 44:  /* *movhi_lo_sum */
    case 8:  /* *cmptf_fp */
    case 7:  /* *cmpdf_fp */
    case 6:  /* *cmpsf_fp */
    case 5:  /* *cmptf_fpe */
    case 4:  /* *cmpdf_fpe */
    case 3:  /* *cmpsf_fpe */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 238:  /* *cmp_ccnz_ashift_1 */
    case 196:  /* *cmp_cc_not */
    case 188:  /* *cmp_ccnz_neg */
    case 91:  /* *cmp_siqi_trunc */
    case 87:  /* *cmp_zero_extendqisi2 */
    case 2:  /* *cmpsi_sne */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 1:  /* *cmpsi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    }
}
